package at.ac.uibk.gitsearch.service;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.mockito.MockitoAnnotations;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import at.ac.uibk.gitsearch.GitsearchApp;
import at.ac.uibk.gitsearch.service.dto.SearchInputDTO;
import at.ac.uibk.gitsearch.service.dto.SearchResultsDTO;

/**
 * Integration tests for {@link MailService}.
 */
@SpringBootTest(classes = GitsearchApp.class)
public class SearchServiceIT {

	@Autowired
    private SearchService searchService;

    @BeforeEach
    public void setup() {
        MockitoAnnotations.initMocks(this);
    }

    @Test
    public void testTestData() throws Exception {
    	SearchInputDTO searchQuery = new SearchInputDTO("Just Testing", null, null, null, null, null, null, null, null, 0);
    	// first page
    	SearchResultsDTO searchResultPage = searchService.searchResultPage(searchQuery, 0, SearchInputDTO.PAGE_SIZE);
    	
    	org.junit.Assert.assertNotNull(searchResultPage.getSearchResult());
    	org.junit.Assert.assertTrue("At least one test hit", searchResultPage.getHitCount() == SearchService.NUM_TESTRESULTS);
    	org.junit.Assert.assertTrue("At least one test hit", searchResultPage.getSearchResult().size() == SearchInputDTO.PAGE_SIZE);
    	
    	// last page
    	searchResultPage = searchService.searchResultPage(searchQuery, (SearchService.NUM_TESTRESULTS / SearchInputDTO.PAGE_SIZE) * SearchInputDTO.PAGE_SIZE, SearchInputDTO.PAGE_SIZE);
    	org.junit.Assert.assertNotNull(searchResultPage.getSearchResult());
    	org.junit.Assert.assertTrue("At least one test hit", searchResultPage.getHitCount() == SearchService.NUM_TESTRESULTS);
    	org.junit.Assert.assertTrue("At least one test hit", searchResultPage.getSearchResult().size() == SearchService.NUM_TESTRESULTS%10);

    }

}
